package com.example.floradex20

import android.app.Activity
import android.os.Bundle
import android.util.Log
import android.widget.ArrayAdapter
import android.widget.ImageView
import android.widget.TextView
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
//import com.example.floradex20.R
//import com.example.floradex20.Plant
import com.example.floradex20.R
//import com.squareup.picasso.Picasso
import okhttp3.OkHttpClient
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response
import retrofit2.Retrofit
import retrofit2.converter.gson.GsonConverterFactory
//import android.support.v4.app.FragmentActivity
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.fragment.app.FragmentActivity
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.google.gson.Gson


//Cosas para que lleguen las flores
//private const val TOKEN: String = "cMyugCJvk-U_xoi31FVBgoEqZiuRnDYpP8fv8Vfiejg"
private const val  BASE_URL = "https://trefle.io/"
//var slug: String = "prunella-vulgaris"

//Creo que mas cosas para que lleguen las flores
object ServiceBuilder {

    val client = OkHttpClient.Builder().build()

    var retrofit: Retrofit = Retrofit.Builder()
        .baseUrl(BASE_URL)
        .addConverterFactory(GsonConverterFactory.create())
        .client(client)
        .build()

    fun <T> buildService(service: Class<T>): T {
        return retrofit.create(service)
    }
}


//Main Activity
class MainActivity : AppCompatActivity() {
    private lateinit var recyclerView: RecyclerView
//    private lateinit var viewAdapter: RecyclerView.Adapter<PlantList>
//    private lateinit var viewManager: RecyclerView.LayoutManager


    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        val request = ServiceBuilder.buildService(TrefleService::class.java)
        val call : Call<PlantListss> = request.getPlants(getString(R.string.TOKEN))
////        Log.i("Call Plant List", call.toString())
        call.enqueue(object : Callback<PlantListss>{
            override fun onResponse(call: Call<PlantListss>, response: Response<PlantListss>) {
//                Log.i("response", response.body().toString())
                if (response.isSuccessful){
//                    Log.i("Status", "Respones fue succesful")
                    recyclerView = findViewById<RecyclerView>(R.id.recyclerView)
////                        progress_bar.visibility = View.GONE
                    recyclerView.apply {
//                        Log.i("velllllllllllllllllllll", response.body().toString())
                        setHasFixedSize(true)
//                        layoutManager = LinearLayoutManager(this@MainActivity)
//                        adapter = FlowerAdapter(response.body()!!.data)
//                        recyclerView.setAdapter(adapter)
//                        recyclerView.setLayoutManager(layoutManager)
                    }
                }
            }
            override fun onFailure(call: Call<PlantListss>, t: Throwable) {
                Toast.makeText(this@MainActivity, "${t.message}", Toast.LENGTH_SHORT).show()
            }
        })
        }
    }

